/* CSV Parser code sample */
t.1='1002,Mary Jones,320 Main,Denver,CO,84100' 
t.2=' Chemical:,"1,2-Dichlorobenzene Value","1,2-Dichlorobenzene QA Flag",,,1.2345,' 
t.3='"1008","Joe "Hey, guy!" Hall, Jr.","POB 44, ""Apt. 6""",  "Reno " , NV,"89504",,,,' 
t.4=' Chemical:, "1,2-Dichlorobenzene Value","1,2-Dichlorobenzene QA Flag",,,1.2345,'

value. = parse_csv(t.4) -- parse the input line and assign all values to the value. stem
/* Display results using NULL for empty strings and _ for blanks */
Say t.4
Do i=1 To value.0 
  If value.i='' Then fld='NULL'
	Else fld=Changestr(' ',value.i,'_') 
  Say "#"i fld
End i

Exit -- quit program

/* CSV Parser procedure: returns values in a stem variable */
/* the number of values is in the first stem variable (example: csv.0) */
parse_csv: procedure
Parse Arg line
/* Modified from Ian Collier code to handle quotes within quotes, removing leading & trailing quotes, etc */
/* this code not tested to handle the escape character \"  (advice: better don't use it \") */
/* warning: there are embedded newlines within a quoted field in the Microsoft CSV format! */
sep=',' 
qt='"' 
/* some uses a single quote (') as the field delimiter */
escape='\'qt 
dbl=0 
blk=0 
tsep=1 

If Countstr(qt,line)//2 \= 0 | Countstr(escape,line) > 0 Then 
  Do
  Say 'Non valid input string. Non paired quotation marks or escape character found' escape
  Exit
  End
Else Nop

Do i=1 While line\=='' 
fld='' 
fld_type=0 
  Do Until line=='' 
  Parse Var line left (sep) nonsep +1 line 
	If line='' & nonsep=sep Then is_tsep=1; Else is_tsep=0 
	fld=fld||left 
  If Pos(qt,fld)=0 Then Leave 
	Else 
		Do 
		fld_type=1 
 		temp=Strip(fld) 
    If Countstr(qt,temp)//2 = 0 & Left(temp,1)=qt & Right(temp,1)=qt Then
  	  Do 
	  	If \blk & Compare(fld,temp)\=0 Then Say "Warning: blanks arround the quoted field:" temp; Else Nop
			fld=Substr(temp,2,Length(temp)-2) 
			If dbl & Pos(qt||qt,fld)>0 Then fld=Changestr(qt||qt,fld,qt); Else Nop 
		  Leave 
 		  End 
  	Else fld=fld||nonsep 
	  End 
  End 
If blk & \fld_type Then fld=Strip(fld); Else Nop 
csv.i=fld 
End i 

If tsep & is_tsep Then
  Do 
	csv.i='' 
	csv.0=i 
	End
Else csv.0=i-1 

Return csv. --csv_parser
/* End of CSV Parser procedure */

/* Object Rexx code to read a CSV file and assign values to stem variables */
/* input: 2 values in CSV format. Example: "Caption for image 1","image_001.jpg" */
    i = 0
    file=.stream~new('captions.txt')  /* Create stream object */
    lines=file~makearray(line)        /* Read file into an array object */
 	  Do line Over lines                /* Scan the array */
      i = i + 1                       /* Counter */
      value. = csv_parser(line)       /* parse CSV values into the value. stem */
      caption.i = value.1             /* value.1 is the caption */
      filename.i = value.2            /* value.2 is the image filename */
      End --over captions
    filename.0 = i                    /* stem in standard form */
    caption.0 = i                     /* stem in standard form */

